/*** Anfang M_SPOOLE.C ************************************/
#include <stdio.h>
#include <conio.h>
#include <string.h>

/***********************************************************
*    Autor: User-Club-Hannover & toolbox 1991              *
*    Compiler: Turbo C++                                   *
*    EINGABE: Filename                                     *
*    AUSGABE: Status der Operation                         *
*     00h  kein Fehler                                     *
*     01h  Funktionsaufruf falsch                          *
*     02h  Datei nicht gefunden                            *
*     03h  Pfad nicht gefunden                             *
*     04h  zu viele offene Dateien                         *
*     05h  Zugriff verweigert                              *
*     08h  Ausgabeliste voll                               *
*     09h  Treiber belegt                                  *
*     12h  Dateiname zu lang                               *
*     15h  kein Fehler oder falsches Laufwerk              *
*    Funktion: Routine trgt File in die aktuelle Druck-   *
*    Liste des Printerspoolers ein.                        *
***********************************************************/
int m_print(char *Fname)
{
static struct Liste
{
 char Prior;
 int  F_Offset;
 int  F_Segment;
 char Filename[12];
 } Tabelle;

 strcat(Fname, NULL);
 strcpy(Tabelle.Filename, Fname);

 asm mov Tabelle.Prior, 0;
 asm lea dx, Tabelle;            /* Tabelle  DS:dx        */
 asm lea di, Tabelle.Filename;   /* Adr.Filename DS:di    */
 asm mov Tabelle.F_Offset, di;   /* in Tabelle eintragen  */
 asm mov Tabelle.F_Segment, DS;
 asm mov ax, 0101h               /* Funktionsnummer       */
 asm int 2fh                     /* Multiplexer Interrupt */
 return(_AL);
}

/***********************************************************
*    Autor: User-Club Hannover & toolbox 1991              *
*    Compiler: Turbo C++                                   *
*    EINGABE: Keine                                        *
*    AUSGABE: Installationsstatus Druckerspooler           *
*    Funktion: Routine ermittelt den Status des Printer-   *
*    spoolers und gibt folgende Werte zurck:              *
*     FFh  installiert                                     *
*     01h  nicht installiert, Installation nicht mglich   *
*     00h  nicht installiert, Installation mglich         *
***********************************************************/
int m_installed (void)
{
 asm mov ax, 0100h                /* Funktionsnummer      */
 asm int 2fh
 return(_AL);
}
/*******  Ende M_SPOOLE.C  ********************************/
