(* ------------------------------------------------------ *)
(*                     SCRDEMO.PAS                        *)
(*              Demo fr Unit SCREENS.PAS                 *)
(*                    Turbo Pascal 5.5                    *)
(*              (c) 1990 H.Zenz & TOOLBOX                 *)
(* ------------------------------------------------------ *)
PROGRAM ScreenDemo;

USES Crt, Screens;

VAR i    : INTEGER;
    ch   : CHAR;
CONST                { Verzgerungswert fr die Effekte    }
    Dauer: BYTE = 4; { optimal fr 8 Mhz-AT, ggf. anpassen }

PROCEDURE Bildschirm;                { Testbilder aufbauen }
VAR
  n, x, y: BYTE;
CONST
  Meldung  : ARRAY[1..3] OF STRING =
            ('ͻ',
             ' toolbox ',
             'ͼ');
BEGIN
  Randomize;
  Cls(0, 0);
  FOR n := 1 TO 200 DO BEGIN                     { Seite 0 }
    TextColor(Random(8)+8);       { bunte toolbox-Kstchen }
    TextBackground(Random(8));
    x := Random(70);
    y := Random(23);
    for i := 1 TO 3 DO
      WriteStrXY(x, y+i-1, 0, Meldung[i]);
  END;
  Cls(1, Blue);                                  { Seite 1 }
  FOR x := 0 TO 79 DO                      { buntes Muster }
    FOR y := 0 TO 24 DO BEGIN
      TextColor((x+2*y) MOD 16);
      TextBackGround((x*y) MOD 8);
      WriteStrXY(x, y, 1, #176);
    END;
  TextColor(White);
  TextBackground(Red);                  { Meldung anzeigen }
  WriteStrXY(23,11,1,'ͻ');
  WriteStrXY(23,12,1,'  Dies ist ein Demo nach Art  0  ');
  WriteStrXY(23,13,1,'ͼ');
END;

PROCEDURE Ende;
BEGIN
  CopyScreen(2, 0, 0, 0);
  SetPage(0);
  Cls(1, 0);
  CopyScreen(1, 0, Dauer, Random(9) + 1);
  TextBackGround(Black);
  ClrScr;
  Halt;
END;

BEGIN
  SetPage(2);
  Bildschirm;
  i := 1;
  REPEAT
    WriteIntXY(54, 12, 1, i, 2);
    CopyScreen(1, 2, Dauer, i);
    ch := ReadKey;
    IF ch = #27 THEN
      Ende;
    CopyScreen(0, 2, Dauer, i);
    ch := ReadKey;
    IF ch = #27 THEN
      Ende;
    Inc(i);
    IF i > 9 THEN
      i := 1;
  UNTIL FALSE;
END.
(* ------------------------------------------------------ *)
(*                 Ende von SCRDEMO.PAS                   *)
