(* ------------------------------------------------------ *)
(*                     STRFUNC.PAS                        *)
(*                Verschiedene Funktionen                 *)
(*        (c) 1991  Dieter Schmalstieg & TOOLBOX          *)
(* ------------------------------------------------------ *)
UNIT StrFunc;

INTERFACE

  FUNCTION StrL(l : LONGINT; z : BYTE) : STRING;
  FUNCTION ValL(s : STRING) : LONGINT;
  FUNCTION StrR(r : REAL; z, zz : BYTE) : STRING;
  FUNCTION ValR(s : STRING) : REAL;

IMPLEMENTATION

  FUNCTION StrL(l : LONGINT; z : BYTE) : STRING;
  VAR s : STRING;
  BEGIN
    STR(l:z, s);
    StrL := s;
  END;

  FUNCTION ValL;
  VAR v : LONGINT; c : INTEGER;
  BEGIN
    VAL(s, v, c);
    ValL := v;
  END;

  FUNCTION StrR(r : REAL; z, zz : BYTE) : STRING;
  VAR s : STRING;
  BEGIN
    STR(r:z:zz, s);
    StrR := s;
  END;

  FUNCTION ValR;
  VAR v : REAL; c : INTEGER;
  BEGIN
    VAL(s, v, c);
    ValR := v;
  END;

END.
(* ------------------------------------------------------ *)
(*              Ende von STRFUNC.PAS                      *)
