/*--------------------------------------------------------*/
/*                        DEMO.PRG                        */
/*                     fr Clipper 5.0                    */
/*           (C) 1991 Volker Vogeley & TOOLBOX            */
/*--------------------------------------------------------*/

* Einstellungen der Programmumgebung:

ALTD(1)
SET DATE GERMAN
SET TALK OFF
SET SCOREBOARD OFF
SET DELETED ON
SET ESCAPE OFF
SET ECHO OFF
SET INTENSITY ON
SET CURSOR ON
CLOSE

* Variablendefinition fr die Zuweisung der Farben:

IF ISCOLOR()           && Feststellen, ob ein Farbadapter
  farbe1 = "w+/gb"     && vorhanden ist.
  farbe2 = "gr+/gb"
  farbe3 = "gb/b+,gr+/n,n/w,,"
  farbe4 = "r/gb"
  farbe5 = "w+/b,n/w+"
  farbe6 = "w+/b+"
  farbe7 = "r/b+"
Rahme_ein = CHR(201) + CHR(205) + CHR(187) + CHR(186) + ;
            CHR(188) + CHR(205) + CHR(200) + CHR(186) + "#"
ELSE
  farbe1 = "w+/I"
  farbe2 = "w/I"
  farbe3 = "n/w"
  farbe4 = "w/n"
  farbe5 = "w+/n"
  farbe6 = "w+/i"
  farbe7 = "W/n"
Rahme_ein = CHR(201) + CHR(205) + CHR(187) + CHR(186) + ;
            CHR(188) + CHR(205) + CHR(200) + CHR(186) + ""
ENDIF

* Festlegung der Druckercodes der einzelnen Schriftarten:

breitein  = CHR(27) + CHR(87) + "1"
breitaus  = CHR(27) + CHR(87) + "0"
schmalein = CHR(15)
schmalaus = CHR(18)
fettein   = CHR(27) + CHR(69)
fettaus   = CHR(27) + CHR(70)
lqein     = CHR(27) + "x" + "1"
lqaus     = CHR(27) + "x" + "0"
pica      = CHR(27) + CHR(80)
elite     = CHR(27) + CHR(77)
hochgein  = CHR(27) + CHR(83) + "0"
hochgaus  = CHR(27) + CHR(84)
tiefgein  = CHR(27) + CHR(83) + "1"
tiefgaus  = CHR(27) + CHR(84)

* Variablen fr das gesamte Programm festlegen:

* Farbvariablen , die im gesamten Programm genutzt werden:
PUBLIC farbe1, farbe2, farbe3, farbe4, farbe5, farbe6
PUBLIC farbe7, Rahme_ein

* Druckervariablen, die im gesammten Programm zur Steuerung
* der Druckerausgabe verwendet werden:
PUBLIC tiefgein, tiefgaus, hochgein, hochgaus, pica, elite
PUBLIC lqein, lqaus, breitein, breitaus, schmalein
PUBLIC schmalaus fettein, fettaus

SET CONSOLE ON

*                     HAUPTPROGRAMM

CLEAR
Ausw = " "        && Ausw ist eine Variable des Types String
DO WHILE .T.
  zeit = TIME()   && Funktion TIME() gibt die Zeit zurck
  tag  = DATE()   && Funktion DATE() gibt das Datum zurck
  SET COLOR  TO (farbe7) && Farbzuweisung
  * Menleiste darstellen
  @ 1, 0
  @ 22, 0
  text = "****  Sportmanager 1.0  ****"
  SET COLOR TO (farbe5)
  @ 1, (80 - LEN(TRIM(text))) / 2 SAY (text)
  SET COLOR TO (farbe7)
  @  3,  1, 21, 78 BOX SPACE(40)
  @  2,  0, 21, 79 BOX Rahme_ein
  @  0,  0 TO  2, 79 DOUBLE
  @  2,  0 SAY ""
  @  2, 79 SAY ""
  @ 21,  0 TO 23, 79 DOUBLE
  @ 21,  0 SAY ""
  @ 21, 79 SAY ""
  @ 24,  0
  SET COLOR TO (farbe4)
  @ 3, 1 CLEAR TO 20, 78
  SET COLOR TO (farbe3)
  
  * Hauptmen
  SET WRAP ON
  SET MESSAGE TO 24 CENTER
  && Meldungen in Zeile 24 zentriert anzeigen
  @ 22,  2 PROMPT "Trainingsplan";
    MESSAGE "Trainingsplan-Verwaltung"
  @ 22, 17 PROMPT "Trainingsdaten" ;
    MESSAGE "Trainingsdaten-Verwaltung"
  @ 22, 33 PROMPT "Terminkalender" ;
    MESSAGE "Verabstaltungskalender"
  @ 22, 49 PROMPT "Bestenlisten"   ;
    MESSAGE "Bestenlisten-Aufstellung"
  @ 22, 63 PROMPT "Planung" MESSAGE "Rennplanung"
  @ 22, 72 PROMPT "Ende" MESSAGE "Beenden des Sportmanagers"
  
  MENU TO ausw
  DO CASE
    CASE ausw = 1
      SAVE SCREEN TO scr
      @ 12,14 SAY "Sie haben den Menpunkt 1 gewhlt"
      @ 13,14 SAY " Bitte Taste drcken"
      SET CONSOLE OFF
      WAIT TO taste
      SET CONSOLE ON
      * DO PLAN             && Hier knnte ein Unterprogramm
                            && aufgerufen werden.
      RESTORE SCREEN FROM scr
    CASE AUSW = 2
      SAVE SCREEN TO scr
      @ 12,14 SAY "Sie haben den Menpunkt 2 gewhlt"
      @ 13,14 SAY " Bitte Taste drcken"
      SET CONSOLE OFF
      WAIT TO taste
      SET CONSOLE ON
      * DO DATEN1
      RESTORE SCREEN FROM scr
    CASE AUSW = 3
      SAVE SCREEN TO scr
      @ 12,14 SAY "Sie haben den Menpunkt 3 gewhlt"
      @ 13,14 SAY " Bitte Taste drcken"
      SET CONSOLE OFF
      WAIT TO taste
      SET CONSOLE ON
      * DO BESTLIST
      RESTORE SCREEN FROM scr
    CASE AUSW = 4
      SAVE SCREEN TO scr
      @ 12,14 SAY "Sie haben den Menpunkt 4 gewhlt"
      @ 13,14 SAY " Bitte Taste drcken"
      SET CONSOLE OFF
      WAIT TO taste
      SET CONSOLE ON
      * DO KALENDER
      RESTORE SCREEN FROM scr
    CASE AUSW = 5
      SAVE SCREEN TO WETTK
      @ 12,14 SAY "Sie haben den Menpunkt 5 gewhlt"
      @ 13,14 SAY " Bitte Taste drcken"
      SET CONSOLE OFF
      WAIT TO taste
      SET CONSOLE ON
      * DO WETTK
      RESTORE SCREEN FROM wettk
    CASE AUSW = 6 .OR. LastKey() = 27        && Programmende

    *  Programmende mit Sicherheitsabfrage:

    SAVE SCREEN TO ENDSCR
    SET COLOR TO
    CLEAR
    SET COLOR TO (farbe7)
    ende = CHR(213) + CHR(205) + CHR(184) + CHR(179) + ;
           CHR(190) + CHR(205) + CHR(212) + CHR(179) + ""
    @ 4, 2, 14, 77 BOX ende
    z = 6
    SET COLOR TO (farbe1)
    STORE " Sie haben - E N D E -  gewhlt! " TO text
    @ z, (80 - LEN(TRIM(text))) / 2 SAY (TEXT)
    STORE " Wollen Sie wirklich beenden? (J/N) " TO text
    z = z + 4
    SET COLOR TO (farbe1)
    @ z, (80 - LEN(TRIM(text))) / 2 SAY (TEXT)
    FOR i = 1 TO 2
      TONE(940, 5)
      TONE(328, 5)
    NEXT
    SET COLOR TO
    SET CONSOLE OFF
    SET CURSOR OFF
    @ 24, 79
    WAIT TO ewahl
    SET CONSOLE ON
    IF ewahl = "J" .OR. ewahl = "j"
      EXIT
    ELSE
      RESTORE SCREEN FROM endscr
      ausw = " "
    ENDIF
  ENDCASE
ENDDO
CLEAR
SET COLOR TO (farbe4)
@ 2, 8 TO 10, 72 DOUBLE
@ 3, 9 clear TO 9, 71
SET COLOR TO (farbe2)
z = 4
STORE " Vielen Dank fr den Einsatz des Sport - Managers " ;
  TO text
@ z, (80 - LEN(TRIM(text))) / 2 SAY (TEXT)
SET CURSOR OFF
FOR e = 1 TO 2000                            && Zeitschleife
NEXT
?
?
?
?
?
SET COLOR TO   && Farbe auf Standardwerte zurcksetzen
CLOSE ALL      && Alle offnen Dateien schlieen
SET CURSOR ON  && Cursor wieder einschalten
QUIT           && Programm beenden

/*--------------------------------------------------------*/
/*                Ende von DEMO.PRG                       */
