;* ------------------------------------------------------- *
;*                     GRAFDEMO.ASM                        *
;*   Grafikdemo in Assembler, das die Einbindung           *
;*   der Turbo Pascal 3.0 Grafikbibliothek demonstriert.   *
;*           (c) 1991 Ralph Seelig & TOOLBOX               *
;* ------------------------------------------------------- *
include tp3gr.mac

.model small
.stack 800h
.data

  meld     db 'toolbox presents:$'
  meld2    db 'Grafik in Assembler$'
  meld3    db 'Bitte Taste druecken ...$'
  muster   db 81h,7Eh,42h,42h,42h,42h,7Eh,81h

.code
  extrn graph : near

include tp3gr.inc

anfang:
  mov   ax,dgroup
  mov   ds,ax

  tp3   GraphColorMode
  tp3_1 Palette,2
  mov   si,offset meld
  mov   dx,0101h
  mov   bl,03
  call  write      ; an 1,1 MELD ausgeben
  mov   si,offset meld2
  inc   dh
  mov   bl,2
  call  write      ; an 1,2 MELD2 ausgeben
  mov   si,offset meld3
  mov   dh,25
  mov   bl,1
  call  write      ; an 1,25 MELD3 ausgeben

  tp3_4 circle 160,100,50,3
  tp3_4 fillshape 160,100,2,3
  tp3_4 circle 137,83,7,0
  tp3_4 fillshape 137,83,3,0
  tp3_4 circle 183,83,7,0
  tp3_4 fillshape 183,83,3,0
  tp3_5 arc 150,110,28,60,3
  tp3_5 draw 150,110,170,113,3
  tp3_5 draw 132,121,160,125,1
  tp3_5 draw 160,125,188,121,1

  mov   ah,08h
  int   21h        ; auf Taste warten
  tp3   clearscreen
  xor   cx,cx
grschl2:
  mov   ax,160
  xor   bx,bx
  mov   dx,199
  mov   si,3       ; Farbe 3
  push  cx         ; Zhler retten
  pushreg          ; Parameter auf Stack
  push  si
  tp3   draw
  pop   cx         ; Zhler holen
  add   cx,10      ; Zhler erhhen
  cmp   cx,320
  jb    grschl2
  xor   cx,cx
grschl1:
  mov   ax,160
  mov   bx,199
  xor   dx,dx
  mov   si,2       ; Farbe 2
  push  cx         ; Zhler retten
  pushreg          ; Parameter auf Stack legen
  push  si
  tp3   draw
  pop   cx         ; Zhler holen
  add   cx,10      ; Zhler erhhen
  cmp   cx,320
  jb    grschl1

  tp3_5 draw 0,0,319,0,1
  tp3_5 draw 0,199,319,199,1
  tp3_5 draw 0,0,0,199,1
  tp3_5 draw 319,0,319,199,1
  tp3_4 circle,160,100,50,1
  tp3_4 FillShape,160,100,1,1
  tp3_4 circle,160,100,50,2
  tp3_4 FillShape,160,100,0,2
  mov   ax,offset muster
  pushadr
  tp3   Pattern
  tp3_5 FillPattern,130,70,190,130,1

  mov   ah,08h
  int   21h
  mov   ax,03h
  int   10h
  mov   ah,4ch
  int   21h

end anfang
;* ------------------------------------------------------- *
;*                Ende von GRAFDEMO.ASM                    *

