(* ------------------------------------------------------ *)
(*                      PUSHENV.PAS                       *)
(* ------------------------------------------------------ *)
PROGRAM PushMasterEnv;

{$R-,S-,I-,F-,O-,A-,V-,B-,N-,E-,D-,L-}

USES Environ;

VAR
  SaveDatei : FILE OF BYTE;
  Dateiname : STRING;
  Ofs       : WORD;

  FUNCTION UpString(Txt : STRING) : STRING;
  VAR
    i : BYTE;
  BEGIN
    FOR i := 1 TO LENGTH(Txt) DO
      UpString[i] := UpCase(Txt[i]);
    UpString[0] := Txt[0];
  END;

BEGIN
  IF ParamCount < 1 THEN Halt(1);
  Dateiname := ParamStr(1);
  Assign(SaveDatei, Dateiname);
  {$I-} Rewrite(SaveDatei); {$I+}
  IF IOResult <> 0 THEN Halt(1);
  FOR Ofs := 0 TO MasterEnvSize-1 DO
    Write(SaveDatei, Mem[MasterEnvSeg:Ofs]);
  Close(SaveDatei);
  IF UpString(ParamStr(2)) = 'CLEAR' THEN
    FillChar(Mem[MasterEnvSeg:0], MasterEnvSize, 0);
END.
(* ------------------------------------------------------ *)
(*               Ende von PUSHENV.PAS                     *)
