(* Sondertasten der MF2-Tastatur *)

USES Dos;

VAR
  Cde : BYTE;

  FUNCTION ScanKey(VAR Code : BYTE) : CHAR;
  VAR
    Regs : Registers;
  BEGIN
    Regs.AH := $10;   (* nur BIOS AT 03- PS/2 *)
    Intr($16, Regs);
    Code := Regs.AH;
    ScanKey := Chr(Regs.AL);
  END;

  FUNCTION Status : BYTE;
  VAR
    Regs : Registers;
  BEGIN
    Regs.AH := $12;
    Intr($16, Regs);
    Status := Regs.AL
  END;

BEGIN
  Write(ScanKey(Cde));
  Write('  : ', Cde);
  Write('  : ', Status);
END.
