(* ------------------------------------------------------ *)
(*                      HOME.PAS                          *)
(*         Erzeugen eines "Heimatverzeichnisses".         *)
(*        Rckkehr mit 'homedir'; auch nach Reset.        *)
(*             (c) 1991 W.Rinke & TOOLBOX                 *)
(* ------------------------------------------------------ *)
PROGRAM Home;

USES Dos;

VAR
  LW  : STRING[2];
  Dir : STRING;
  f   : TEXT;
  com : STRING;

  FUNCTION GetAPathDir : STRING;
  VAR
    s       : STRING;
    semipos : INTEGER;
  BEGIN
    s := GetEnv('PATH');
    semipos := Pos(';', s);
    IF semipos > 0 THEN
      GetAPathDir := Copy(s, 1, semipos-1)
    ELSE
      GetAPathDir := s;
  END;

BEGIN
  Assign(f, GetAPathDir + '\HOMEDIR.BAT');
  Rewrite(f);
  GetDir(0, Dir);
  LW := Copy(Dir, 1, 2);
  IF DosVersion >= $1E03 THEN               (* ab Dos 3.3 *)
    Write(f, '@');
  WriteLn('ECHO OFF');
  WriteLn(f, LW);
  WriteLn(f, 'cd ', Dir);
  Close(f);
END.
(* ------------------------------------------------------ *)
(*               Ende von HOME.PAS                        *)
