(* ------------------------------------------------------ *)
(*                    SETVPAGE.PAS                        *)
(*  Das Beispiel-Programm aus dem Turbo-Pascal-Handbuch   *)
(*  fr SetXXXPage, jetzt auch fr CGA,                   *)
(*  aber immer noch kompatibel zu anderen!                *)
(* ------------------------------------------------------ *)
PROGRAM SetVPage;

USES Graph, SetPage;

VAR
  Gd, Gm : INTEGER;

BEGIN
  Gd := Detect;
  InitGraph(Gd, Gm, '');
  IF GraphResult <> grOk THEN Halt(1);
  IF (Gd = HercMono) OR (Gd = EGA) OR
     (Gd = EGA64)    OR (Gd = VGA) OR
     (Gd = CGA) THEN BEGIN
    SetVisualPage(0);
    SetActivePage(1);
    Rectangle(10, 20, 30, 40);
    IF (Gd = CGA) THEN
      OutText('Paging supported!');
    SetVisualPage(1);
  END ELSE
    OutText('No paging supported.');
  ReadLn;
  CloseGraph;
END.
(* ------------------------------------------------------ *)
(*                 Ende von SETVPAGE.PAS                  *)

