@echo off
REM Installs Fractal Grafics to a hard disk.
if exist STARTUP.PCX goto start
echo You have not yet specified your graphics adapter.
echo For instructions, type INSTALL and press Enter.
goto end
:start
set fgdir=C:\FRACTAL
if not "%1"=="" set fgdir=%1
echo Now installing Fractal Grafics to the %fgdir% directory...
mkdir %fgdir%
if exist FG.EXE goto findjul
echo Unable to locate the Fractal Grafics program.
goto checkmsg
:findjul
if exist JULIMAN.EXE goto findhelp
echo Unable to locate the Juliman program.
goto checkmsg
:findhelp
if not exist HELP\HELP1.FRT goto missing
goto copyit
:missing
echo Unable to locate the on-line help files.
:checkmsg
echo Check to make sure you have the correct disk.
echo (Fractal Grafics has NOT been installed.)
goto end
:copyit
xcopy FG.EXE %fgdir% /v
xcopy JULIMAN.EXE %fgdir% /v
xcopy *.FRT %fgdir% /v
xcopy *.PCX %fgdir% /v
mkdir %fgdir%\HELP
xcopy HELP\*.FRT %fgdir%\HELP /v
if exist EXAMPLES\SQUARE.FRT goto exams
echo Fractal Grafics has been installed to the %fgdir% directory.
echo To copy the example files to the hard disk, insert the EXAMPLES disk,
echo type COPYEXAM %fgdir% and press the Enter key.
goto end
:exams
md %fgdir%\EXAMPLES
xcopy EXAMPLES\*.* %fgdir%\EXAMPLES /v
type %0.TXT
:end

