(* ------------------------------------------------------ *)
(*                  MEMOSWAP.PAS                          *)
(*  Schnelles Vertauschen von Variablen und Speicher-     *)
(*  bereichen ohne temprare Variablen.                   *)
(*         (c) 1990 Hulusi Zorba & TOOLBOX                *)
(* ------------------------------------------------------ *)
{$D-}
{$M 1024,0,0}

UNIT MemoSwap;

INTERFACE

  PROCEDURE SwapMem(p1,p2 : Pointer; Count : Word);
  PROCEDURE SwapByte(VAR b1,b2);
  PROCEDURE SwapWord(VAR w1,w2);
  PROCEDURE SwapReal(VAR w1,w2);

IMPLEMENTATION

  PROCEDURE SwapMem(p1,p2 : Pointer; Count : Word);
  EXTERNAL;

  PROCEDURE SwapByte(VAR b1,b2); EXTERNAL;

  PROCEDURE SwapWord(VAR w1,w2); EXTERNAL;

  PROCEDURE SwapReal(VAR w1,w2); EXTERNAL;

{$L MemoSwap}

END.
(* ------------------------------------------------------ *)
(*                Ende von MEMOSWAP.PAS                   *)

