(* ------------------------------------------------------ *)
(*                    POPENV.PAS                          *)
(* ------------------------------------------------------ *)
PROGRAM PopMasterEnv;

{$R-,S-,I-,F-,O-,A-,V-,B-,N-,E-,D-,L-}

USES Environ;

VAR
  SaveDatei : FILE OF BYTE;
  Dateiname : STRING;
  Ofs       : WORD;

BEGIN
  IF ParamCount < 1 THEN Halt(1);
  Dateiname := ParamStr(1);
  Assign(SaveDatei, Dateiname);
  {$I-} Reset(SaveDatei); {$I+}
  IF IOResult <> 0 THEN Halt(1);
  FOR Ofs := 0 TO MasterEnvSize-1 DO
    Read(SaveDatei, Mem[MasterEnvSeg:Ofs]);
  Close(SaveDatei);
  Erase(SaveDatei);
END.
(* ------------------------------------------------------ *)
(*                Ende von POPENV.PAS                     *)
