(* ------------------------------------------------------- *)
(*                     TEST_OVR.PAS                        *)
(*     Test-Beispiel fr Auslagerung in ext. Memory        *)
(* ------------------------------------------------------- *)
USES
  Overlay, OvrXMS, DOS, CRT;

{$O DOS}

BEGIN
  ClrScr;
  WriteLn('Ŀ');
  WriteLn('  Demonstriert Auslagerung von Overlays  ');
  WriteLn('     (c) 1991 D.Schneider & TOOLBOX      ');
  WriteLn('');
  WriteLn;
  OvrInit('Test_ovr.ovr');
  OvrInitXMS;
  IF OvrResult = ovrOK THEN BEGIN
    WriteLn('DOS-Unit wurde als Overlay ausgelagert');
    WriteLn;
    WriteLn('jetzt wird der Overlay-Puffer gelscht.');
    OvrClearBuf;
    WriteLn;
    WriteLn('jetzt wird die DOS-Unit benutzt');
    WriteLn;
    WriteLn('akt. LW hat ', DiskSize(0), ' Bytes');
    WriteLn('akt. LW hat ', Diskfree(0), ' Bytes frei');
  END ELSE BEGIN
    IF OvrResult = ovrNoXMSDriver THEN BEGIN
      WriteLn(' Kein XMS Treiber installiert');
      WriteLn(' HIDOS.SYS fr DRDOS, ');
      WriteLn(' HIMEM.SYS fr MSDOS einbinden !!');
    END ELSE IF OvrResult = ovrNoXMSMemory THEN
      WriteLn('nicht gengend ext. Memory frei !')
    ELSE
      WriteLn('allgemeiner Overlay-Fehler');
    END;
  WriteLn;
  WriteLn('press ESC');
  REPEAT UNTIL ReadKey = ^[;
END.
(* ------------------------------------------------------- *)
(*               Ende von TEST_OVR.PAS                     *)

